package valasztas;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Scanner;

public class Valasztas {

	public static void main(String[] args) {

		ArrayList<Candidate> candidates = new ArrayList<Candidate>();

		// 1. feladat - adatok beolvassa
		System.out.println("\n1. feladat");
		try {
			BufferedReader fr = new BufferedReader(new FileReader(
					"szavazatok.txt"));
			String adat;
			while ((adat = fr.readLine()) != null) {
				candidates.add(new Candidate(adat.split(" ")));
			}
			fr.close();
		} catch (Exception e) {
			System.err.println("Fajlbeolvasasi vagy konvertalasi hiba "
					+ e.getMessage());
		}

		// 2. feladat - adatok szma
		System.out.println("\n2. feladat");
		System.out.println("A helyhatosagi valasztason " + candidates.size()
				+ " kepviselojelolt indult.");

		// 3. feladat - keress
		System.out.println("\n3. feladat");
		Scanner scan = new Scanner(System.in);
		System.out.print("Adja meg a kepviselo vezeteknevet: ");
		String fname = scan.nextLine();
		System.out.print("Adja meg a kepviselo keresztnevet: ");
		String sname = scan.nextLine();
		int index = 0;
		while (index < candidates.size()
				&& !(candidates.get(index).getFname().compareTo(fname) == 0 && candidates
						.get(index).getSname().compareTo(sname) == 0)) {
			index++;
		}
		if (index == candidates.size()) {
			System.out
					.println("Ilyen nevu kepviselojelolt nem szerepel a nyilvantartasban!");
		} else {
			System.out.println("A kepviselo " + candidates.get(index).getVote()
					+ " szavazatot kapott");
		}

		// 4. feladat - sszegzs
		System.out.println("\n4. feladat");
		int sum = 0;
		for (Candidate candidate : candidates) {
			sum += candidate.getVote();
		}

		NumberFormat percent = new DecimalFormat("0.00%");
		System.out.println("A valasztason " + sum
				+ " allampolgar, a jogosultak "
				+ percent.format(sum * 1.0 / 12345) + "-a vett reszt.");

		// 5. feladat - prtonknti eredmny
		System.out.println("\n5. feladat");
		int[] psum = new int[5];
		for (Candidate candidate : candidates) {
			psum[candidate.getPart().ordinal()] += candidate.getVote();
		}

		System.out.println("Gyumolcsevok Partja = "
				+ percent.format(psum[0] * 1.0 / sum));
		System.out.println("Husevok Partja = "
				+ percent.format(psum[1] * 1.0 / sum));
		System.out.println("Tejivok Szovetsege = "
				+ percent.format(psum[2] * 1.0 / sum));
		System.out.println("Zoldsegevok Partja = "
				+ percent.format(psum[3] * 1.0 / sum));
		System.out.println("Fuggetlen jeloltek = "
				+ percent.format(psum[0] * 1.0 / sum));

		// 6. feladat - legjobbak
		System.out.println("\n6. feladat");
		System.out.println("A legtobb szavazatot szerzo kepviselok");
		int max = candidates.get(0).getVote();
		for (Candidate candidate : candidates) {
			if (candidate.getVote() > max) {
				max = candidate.getVote();
			}
		}
		for (Candidate candidate : candidates) {
			if (candidate.getVote() == max) {
				System.out.println("\t" + candidate.Name() + "-"
						+ candidate.getPart().name());
			}
		}

		// 7. feladat - eredmny kirsa fjlba
		System.out.println("\n7. feladat");
		int[] areaMax = new int[9];
		for (Candidate candidate : candidates) {
			if (candidate.getVote() > areaMax[candidate.getAreaCode()]) {
				areaMax[candidate.getAreaCode()] = candidate.getVote();
			}
		}
		try {
			// FileWriter fw = new FileWriter("kepviselok.txt");
			PrintWriter pw = new PrintWriter(new FileWriter("kepviselok.txt"));

			for (int i = 1; i < areaMax.length; i++) {
				int j = 0;
				while (!(candidates.get(j).getAreaCode() == i && candidates
						.get(j).getVote() == areaMax[i])) {
					j++;
				}
				pw.println(i + ". " + candidates.get(j).Name() + " "
						+ candidates.get(j).getPart().name());
			}
			pw.close();
			// fw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		System.out.println("kesz");
		scan.nextLine();
	}

}
